{  Demonstriert wird in der Prozedur
   Bubblesort(aa:array of real; n1,n2:integer)
   der Algorithmus "Bubblersort" fr aa[n1] ... aa[n2]:
   Wiedehole, bis kein Vertauschen mehr notwendig:
   fr i:=n1 to n2: wenn aa[i]>aa[i+1], dann tausche die beiden.
------------------------------------------------------------
Effizienz: Doppelt so viele Daten:viermal so viele Vergleiche
           Drei mal so viele Daten:Neunmal so viele Vergleiche.

      Effiziens ist von der Ordnung(n^2)
      ==================================

z.b. bei einem Datensatz 10 min. Bei einem 100 mal so groen Datensatz
     100 000 min= ca 10 Wochen

Stichworte: Ordnen
            Bubblesort
            Effizienz
}


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    BFuellen: TButton;
    BOrdnen: TButton;
    EAnzahl: TEdit;
    Label1: TLabel;
    BSchliessen: TButton;
    procedure BFuellenClick(Sender: TObject);
    procedure BOrdnenClick(Sender: TObject);
    procedure BSchliessenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure tausche(var a,b:real);
  var x:real;
begin
  x:=a;
  a:=b;
  b:=x;
end;

procedure bubblesort(var aa:array of real; n1,n2:integer); //sortiert von n1 bis n2
  var i:integer;
      fertig: Boolean;
begin
  repeat
    fertig:=true;
    for i:=n1 to n2-1 do Begin
      if aa[i]>aa[i+1] then BEgin
        tausche(aa[i],aa[i+1]);
        fertig:=false;
      ENd;
    End;
  until fertig;
end;


procedure zeige(mm:Tmemo; aa:array of real);
  var i:integer;
begin
  mm.Lines.Clear;
  for i:=0 to length(aa)-1 do mm.Lines.Add(FloatToStr(aa[i]));
end;

procedure TForm1.BFuellenClick(Sender: TObject);
  var i,anzahl:integer;
      aa:array of real;
begin
  anzahl:=strToInt(EAnzahl.text);
  setlength(aa,anzahl);
  for i:=0 to Anzahl-1 do aa[i]:=i+1;
  //Durcheinanderwirbeln
  randomize;
  for i:=0 to Anzahl-1 do tausche(aa[i],aa[random(Anzahl)]);
  zeige(memo1,aa);
end;

procedure TForm1.BOrdnenClick(Sender: TObject);
  var aa:array of real;
     n,i:integer;
begin
  n:=strToInt(EAnzahl.text);
  setlength(aa,n); //n Pltze fr aa[0] bis aa[n-1] reserviert
  for i:=0 to n-1 do aa[i]:=StrToFloat(memo1.lines[i]);
  bubblesort(aa,0,n-1);
  zeige(memo2,aa);
end;

procedure TForm1.BSchliessenClick(Sender: TObject);
begin
  close
end;

end.
